/**
 *
 * @module fun-generator
 */
;(function () {
  'use strict'

  /* imports */
  const { run } = require('monad-state')
  const object = require('fun-object')
  const { curry } = require('fun-function')
  const pseudo = require('./pseudo')
  const { char, tuple, vectorOf, int } = require('.')

  // quickcheck :: Testable a => a -> IO ()

  // class Testable a where
  //   test :: a -> RandSupply -> Bool

  // class Arbirtrary a where
  //   arb :: RandSupply -> a

  // instance Testable Bool where
  //   test b r = b

  // instance (Arbirtrary a, Testable b) => Testable (a -> b) where
  //   test f r - test (f (arb r1)) r2 where
  //     (r1, r2) = split r

  const { pair } = (() => {
    // int:: RandSupply -> int
    // int:: int -> int -> (Seed -> [Seed, a]) -> Seed -> [Seed, int]

    const pair = (arbA, arbB, s0) =>
      tuple([arbA, arbB], s0)

    const api = { pair }
    return object.map(curry, api)
  })()

  const main = () => {
    const s0 = Date.now()
    console.log(`seed: ${s0}`)

    const arbInt = int(-50, 50, pseudo)
    const arbChar = char('abcdefghijklmnopqrstuvwxyz', pseudo)

    const log = x =>
      console.log('random tuple[int, char, char, pair[int, int]]:', x)

    const aTuple = tuple([arbInt, arbChar, arbChar, pair(arbInt, arbInt)])
    const values = vectorOf(11, aTuple)
    // test: s -> [bool, s]

    run(s0, values).forEach(log)
  }

  main()
})()

